'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _join = require('../../utils/join');

var _join2 = _interopRequireDefault(_join);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _ColumnGroupInnerWrapper = require('./ColumnGroupInnerWrapper');

var _ColumnGroupInnerWrapper2 = _interopRequireDefault(_ColumnGroupInnerWrapper);

var _Column = require('../../Column');

var _Column2 = _interopRequireDefault(_Column);

var _getColumnsWidth = require('../../utils/getColumnsWidth');

var _getColumnsWidth2 = _interopRequireDefault(_getColumnsWidth);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ColumnGroup = function (_Component) {
  _inherits(ColumnGroup, _Component);

  function ColumnGroup(props) {
    _classCallCheck(this, ColumnGroup);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ColumnGroup).call(this, props));

    _this.state = {
      columns: _this.getColumns(props)
    };
    return _this;
  }

  _createClass(ColumnGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.columns !== this.props.columns || nextProps.children !== this.props.children) {
        this.setState({
          columns: this.getColumns(nextProps)
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var viewportHeight = props.viewportHeight;
      var width = props.width;
      var chilren = props.chilren;
      var fixed = props.fixed;
      var innerWrapperOffset = props.innerWrapperOffset;


      var style = (0, _objectAssign2.default)({}, props.style, {
        height: viewportHeight
      });

      var columns = this.state.columns;

      if (width !== undefined) {
        style.width = width;
      }

      var minWidth = (0, _getColumnsWidth2.default)(columns);

      // Fixed means that it is not allowed to have horizontal scroll
      if (fixed) {
        style.minWidth = minWidth;
      }

      var className = (0, _join2.default)('react-datagrid__colum-group', props.className);

      var innerWrapperStyle = {
        transform: 'translate3d(0,' + innerWrapperOffset + 'px, 0)'
      };

      return _react2.default.createElement(
        'div',
        _extends({}, props, {
          className: className,
          style: style,
          data: null,
          onScroll: this.onScroll
        }),
        _react2.default.createElement(
          'div',
          { style: innerWrapperStyle },
          _react2.default.createElement(_ColumnGroupInnerWrapper2.default, _extends({}, props, { columns: columns, minWidth: minWidth, innerWrapperOffset: null }))
        )
      );
    }
  }, {
    key: 'onScroll',
    value: function onScroll(ev) {
      ev.stopPropagation();
      this.props.onScroll(ev);
    }
  }, {
    key: 'getColumns',
    value: function getColumns(props) {
      props = props || this.props;
      var children = props.children;

      // We want to allow users to use columns configuration as jsx
      // or as an array of config objects
      var columns = void 0;
      if (children) {
        // if we have children, we want to take only valid children
        columns = _react2.default.Children.toArray(children).filter(function (child) {
          return child && child.props && child.props.isColumn;
        });
      } else {
        // used to add default props
        columns = props.columns.map(function (column) {
          return _react2.default.createElement(_Column2.default, column);
        });
      }

      return columns.map(function (c) {
        return c.props;
      });
    }
  }]);

  return ColumnGroup;
}(_reactClass2.default);

exports.default = ColumnGroup;


ColumnGroup.defaultProps = {
  isColumnGroup: true
};

ColumnGroup.propTypes = {
  children: function children(props, propName) {
    var children = props[propName];

    _react2.default.Children.map(children, function (child) {
      if (!child || !child.props || !child.props.isColumn) {
        return new Error('The only children allowed of Datagrid are ColumnGroup');
      }
    });
  },
  onRowMouseEnter: _react.PropTypes.func,
  onRowMouseLeave: _react.PropTypes.func
};