'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Column = exports.ColumnGroup = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _reactFlex = require('react-flex');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _join = require('./utils/join');

var _join2 = _interopRequireDefault(_join);

var _reactLoadMask = require('react-load-mask');

var _reactLoadMask2 = _interopRequireDefault(_reactLoadMask);

var _hasown = require('hasown');

var _hasown2 = _interopRequireDefault(_hasown);

var _Header = require('./Header');

var _Header2 = _interopRequireDefault(_Header);

var _Body = require('./Body');

var _Body2 = _interopRequireDefault(_Body);

var _ColumnGroup = require('./Body/ColumnGroup');

var _ColumnGroup2 = _interopRequireDefault(_ColumnGroup);

var _NavigationHelper = require('./NavigationHelper');

var _NavigationHelper2 = _interopRequireDefault(_NavigationHelper);

require('react-load-mask/index.css');

var _rowSelect = require('./rowSelect');

var _rowSelect2 = _interopRequireDefault(_rowSelect);

var _Column = require('./Column');

var _Column2 = _interopRequireDefault(_Column);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCREEN_HEIGHT = global.screen && global.screen.height;

var DataGrid = function (_Component) {
  _inherits(DataGrid, _Component);

  function DataGrid(props) {
    _classCallCheck(this, DataGrid);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(DataGrid).call(this, props));

    var isLoading = props.dataSource && !!props.dataSource.then;

    _this.state = {
      loading: isLoading,
      data: false,
      selected: props.defaultSelected,
      activeIndex: props.defaultActiveIndex
    };
    return _this;
  }

  _createClass(DataGrid, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var dataGridNode = (0, _reactDom.findDOMNode)(this.refs.dataGrid);

      // load data
      this.loadSourceData(this.props.dataSource, this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextState) {

      // data is cached in state
      // needs to be updated if dataSource changes
      if (this.p.dataSource !== nextProps.dataSource) {
        this.loadSourceData(nextProps.dataSource, nextProps);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var preparedProps = this.p = this.prepareProps(this.props, this.state);

      var columns = preparedProps.columns;
      var hideHeader = preparedProps.hideHeader;
      var loading = preparedProps.loading;
      var className = preparedProps.className;
      var children = preparedProps.children;


      return _react2.default.createElement(
        _reactFlex.Flex,
        _extends({}, this.props, {
          ref: 'dataGrid',
          className: className,
          column: true,
          flex: true,
          alignItems: 'stretch',
          wrap: false
        }),
        loading && this.renderLoadMask(),
        !hideHeader && _react2.default.createElement(_Header2.default, {
          columns: columns,
          columnGroups: children
        }),
        _react2.default.createElement(_Body2.default, _extends({}, preparedProps, {
          ref: 'body',
          onRowClick: this.onRowClick,
          onRowFocus: this.onRowFocus
        })),
        _react2.default.createElement(_NavigationHelper2.default, {
          ref: 'NavigationHelper',
          onArrowUp: this.onArrowUp,
          onArrowDown: this.onArrowDown
        })
      );
    }
  }, {
    key: 'renderLoadMask',
    value: function renderLoadMask() {
      return _react2.default.createElement(_reactLoadMask2.default, {
        visible: true,
        className: 'react-datagrid__load-mask'
      });
    }
  }, {
    key: 'onRowClick',
    value: function onRowClick(event, rowProps) {
      this.handleSelection(rowProps, event);
    }
  }, {
    key: 'onRowFocus',
    value: function onRowFocus(event, rowProps) {
      var newActiveIndex = void 0;

      // check if the event comes from the row and not one of it's children
      if (event.target === event.currentTarget) {
        newActiveIndex = rowProps.realIndex;

        this.refs.NavigationHelper.focus();
      } else {
        newActiveIndex = -1;
      }

      this.setState({
        activeIndex: newActiveIndex
      });
    }
  }, {
    key: 'onArrowUp',
    value: function onArrowUp(event, rowProps) {
      if (!this.p.isActiveIndexControlled) {
        var newIndex = this.state.activeIndex - 1;

        if (newIndex >= 0) {
          this.changeActiveIndex(newIndex, rowProps);
        }
      }
    }
  }, {
    key: 'onArrowDown',
    value: function onArrowDown(event, rowProps) {
      if (!this.p.isActiveIndexControlled) {
        var newIndex = this.state.activeIndex + 1;

        if (newIndex !== this.p.data.length) {
          this.changeActiveIndex(newIndex, rowProps);
        }
      }
    }
  }, {
    key: 'changeActiveIndex',
    value: function changeActiveIndex(newIndex) {
      var scrollTop = this.getScrollTop();
      var bodyHeight = this.getBodyHeight();
      var rowScrollTop = newIndex * this.props.rowHeight;

      // scroll to item if is not visible
      if (scrollTop > rowScrollTop) {
        this.scrollToIndex(newIndex);
      }

      // bottom
      if (scrollTop + bodyHeight < rowScrollTop + this.props.rowHeight) {
        this.scrollToIndex(newIndex, { position: 'bottom' });
      }

      this.setState({
        activeIndex: newIndex
      });

      this.props.onActiveIndexChange(newIndex);
    }

    // handles source data it it is array, it is passed directly to setData
    // if is a promise, sets loading flat to true, when resolves passes data to setData

  }, {
    key: 'loadSourceData',
    value: function loadSourceData(dataSource, props) {
      var _this2 = this;

      if (dataSource === null) {
        this.setData(null);
        return;
      }

      if (Array.isArray(dataSource)) {
        this.setData(dataSource);
      }

      if (dataSource.then) {
        if (props.onDataSourceResponse) {
          dataSource.then(props.onDataSourceResponse, props.onDataSourceResponse);
        }

        this.setState({
          loading: true
        });

        dataSource.then(function (data) {
          if (!Array.isArray(data)) {
            throw new Error('dataSource Promise did not return an array, it returned a ' + (typeof data === 'undefined' ? 'undefined' : _typeof(data)));
          }

          _this2.setData(data);
        });
      }
    }

    /**
     * updates state with data removes loading flag
     * and if selection is enabled creates a hasmap from the data
     * { idProperty: {..}, .. }
     */

  }, {
    key: 'setData',
    value: function setData(data) {
      var _this3 = this;

      var props = this.props;
      var selected = props.selected;
      var defaultSelected = props.defaultSelected;
      var onSelectionChange = props.onSelectionChange;


      var newDataState = {
        data: data,
        loading: false
      };

      // make dataMap only if selected is used
      if (this.isSelectionEnabled() && data !== null) {
        newDataState.dataMap = data.reduce(function (acc, item) {
          acc[_this3.getItemId(item)] = item;
          return acc;
        }, {});
      }

      this.setState(newDataState);
    }
  }, {
    key: 'getItemId',
    value: function getItemId(item) {
      return item[this.props.idProperty];
    }
  }, {
    key: 'getSelected',
    value: function getSelected() {
      return this.isSelectionControlled() ? this.props.selected : this.state.selected;
    }
  }, {
    key: 'isSelectionControlled',
    value: function isSelectionControlled() {
      return this.props.selected !== undefined;
    }
  }, {
    key: 'isSelectionEnabled',
    value: function isSelectionEnabled() {
      var selected = this.props.selected;
      var defaultSelected = this.props.defaultSelected;

      return selected !== undefined || defaultSelected !== undefined;
    }

    /**
     * selected can be an object is case of multiselect
     * or a string or number in case of single select
     */

  }, {
    key: 'isSelectionEmptry',
    value: function isSelectionEmptry() {
      var selected = this.getSelected();
      var selectionEmptry = false;

      if (selected === undefined) {
        selectionEmptry = true;
      }

      if ((typeof selected === 'undefined' ? 'undefined' : _typeof(selected)) === 'object' && selected !== null) {
        selectionEmptry = Object.keys(selected).length === 0;
      }

      return selectionEmptry;
    }

    /**
     * creates an object with props, that can come from
     * this.props, this.state, or computed
     * it is helpful to have a single point of access
     */

  }, {
    key: 'prepareProps',
    value: function prepareProps(props, state) {
      var loading = props.loading == undefined ? this.state.loading : props.loading;

      var className = (0, _join2.default)(props.className, 'react-datagrid');
      var selected = this.getSelected();
      var hasSelection = !this.isSelectionEmptry();

      /**
       * content height, is the hight of the container that hods all the rows, if the all the rows
       * are rendered, it is used for virtual scroll, based on it we know what to render
       */
      var contentHeight = props.rowHeight * (state.data ? state.data.length : 0) + props.scrollbarWidth;
      var isMultiselect = (typeof selected === 'undefined' ? 'undefined' : _typeof(selected)) === 'object' && selected !== null;

      // active index is used for rows navigation
      var activeIndex = props.activeIndex !== undefined ? props.activeIndex : this.state.activeIndex;
      var isActiveIndexControlled = this.props.activeIndex !== undefined;

      return (0, _objectAssign2.default)({}, props, {
        loading: loading,
        selected: selected,
        hasSelection: hasSelection,
        contentHeight: contentHeight,
        isMultiselect: isMultiselect,
        className: className,
        data: state.data,
        activeIndex: activeIndex
      });
    }

    // exposed methods on body component

  }, {
    key: 'scrollAt',
    value: function scrollAt(scrollTop) {
      return this.refs.body.component.scrollAt(scrollTop);
    }
  }, {
    key: 'scrollToIndex',
    value: function scrollToIndex() {
      var _refs$body$component;

      return (_refs$body$component = this.refs.body.component).scrollToIndex.apply(_refs$body$component, arguments);
    }
  }, {
    key: 'scrollToId',
    value: function scrollToId() {
      var _refs$body$component2;

      return (_refs$body$component2 = this.refs.body.component).scrollToId.apply(_refs$body$component2, arguments);
    }
  }, {
    key: 'getScrollTop',
    value: function getScrollTop() {
      return this.refs.body.component.getScrollTop();
    }
  }, {
    key: 'getBodyHeight',
    value: function getBodyHeight() {
      return this.refs.body.component.getBodyHeight();
    }
  }]);

  return DataGrid;
}(_reactClass2.default);

DataGrid.defaultProps = {
  defaultLoading: false,
  hideHeader: false,
  onRowMouseEnter: function onRowMouseEnter() {},
  onRowMouseLeave: function onRowMouseLeave() {},
  onScrollBottom: function onScrollBottom() {},
  onActiveIndexChange: function onActiveIndexChange() {},
  rowProps: {},
  defaultSelected: undefined,
  defaultActiveIndex: -1,
  scrollbarWidth: 20,
  rowPlaceholder: false
};

DataGrid.propTypes = {
  idProperty: _react2.default.PropTypes.string.isRequired,
  loading: _react2.default.PropTypes.bool,
  hideHeader: _react.PropTypes.bool,
  defaultLoading: _react2.default.PropTypes.bool,

  // row config
  onRowMouseEnter: _react.PropTypes.func,
  onRowMouseLeave: _react.PropTypes.func,

  /**
   * TODO: refactor find a more elengant way of declaring placeholder
   * you should be able to configure placeholder global on dataGrid
   * and also on ColumnGroup
   */
  rowPlaceholder: _react.PropTypes.bool,
  renderRowPlaceholder: _react.PropTypes.func,
  rowPlaceholderDelay: _react.PropTypes.number,

  // scrolling and scroll
  onScroll: _react.PropTypes.func,
  onScrollBottom: _react.PropTypes.func,
  scrollToIndex: _react.PropTypes.func,
  scrollToId: _react.PropTypes.func,
  scrollbarWidth: _react.PropTypes.number,

  // selection
  selected: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string, _react.PropTypes.object]),
  defaultSelected: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string, _react.PropTypes.object]),
  onSelectionChange: _react.PropTypes.func,

  // navigation
  activeIndex: _react.PropTypes.number,
  defaultActiveIndex: _react.PropTypes.number,
  onActiveIndexChange: _react.PropTypes.func,

  // columns config
  columns: _react.PropTypes.arrayOf(function (props, propName) {
    var column = props[propName];
    if (!column.name && typeof column.render != 'function') {
      return new Error('column ' + propName + ' should have a "name" prop or a "render" function!');
    }
  }),
  children: function children(props, propName) {
    var children = props[propName];

    _react2.default.Children.map(children, function (child) {
      if (!child || !child.props || !child.props.isColumnGroup || !child.props.isColumn) {
        return new Error('The only children allowed of Datagrid are ColumnGroup and Column');
      }
    });
  },

  // data
  dataSource: function dataSource(props, propName) {
    var dataSource = props[propName];

    if (dataSource === undefined) {
      return new Error('dataSource prop is required.');
    }

    if (dataSource !== null && !Array.isArray(dataSource) && !(dataSource && dataSource.then)) {
      return new Error('dataSource must be an array, null or a promise.');
    }
  },
  onDataSourceResponse: _react.PropTypes.func
};

DataGrid.prototype = (0, _objectAssign2.default)(DataGrid.prototype, _rowSelect2.default);

exports.default = DataGrid;


// you can configurate the grid using an array of configuration objects
// or declaratively (jsx) using ColumnGroup and Column.
exports.ColumnGroup = _ColumnGroup2.default;
exports.Column // Column is a dummy componnet only used for configuration
 = _Column2.default;